#フキダシテンプレート
class SpeechBalloonTemplate < ActiveRecord::Base
  has_many :speech_balloons
  
  validates :name, :presence => true, :uniqueness => true, :length => {:maximum => 50}
  validates :classname, :presence => true, :length => {:maximum => 50}
  validates :caption, :presence => true, :length => {:maximum => 30}
  validates :t, :presence => true, :numericality => {:greater_than_or_equal_to => 0}
  validates :settings, :presence => true
  
  def supply_default
  end
  
  def overwrite
    self.t = SpeechBalloonTemplate.count.to_i if self.new_record?
  end
  
  def visible? author
    true
  end
  
  def self.list
    opt = {}
    opt.merge!(self.list_opt)
    opt.merge!({:order => 'speech_balloon_templates.t asc'})
    SpeechBalloonTemplate.find(:all, opt)
  end
  
  def self.list_opt
    {}
  end
  
  def self.list_json_opt
    {}
  end
  
  def self.show rid, au
    opt = {}
    opt.merge!(self.show_opt)
    res = SpeechBalloonTemplate.find(rid, opt)
    raise ActiveRecord::Forbidden unless res.visible?(au)
    res
  end
  
  def self.show_opt
    {}
  end
  
  def self.show_json_opt
    {}
  end
  
  def self.templates_json_from attr
    #templatesのballoonがフキダシ画像を持っているはずなので置換しておく
    #templates => {hoge => {balloon => system_picture}}
    (attr["templates"] || {}).each do |n, v|
      next if n == 'speech_balloon'
      res = replace_system_picture(v["balloon"] || {})
      return nil if res == false #置換なしでnil 失敗でfalse
    end
    (attr["templates"] || {}).to_json.to_s
  end
  
  def self.store name, attr
    #settingsにはHashデータが丸っと文字列化されて入る
    attr["settings"] = SpeechBalloonTemplate.templates_json_from(attr)
    #templatesデータがあるとフキダシテンプレート生成で邪魔するので削除しておく
    attr.delete "templates"
    r = SpeechBalloonTemplate.modify_object name, attr
    r.overwrite
    r.save
    r
  end
  
  def self.import filename
    SpeechBalloonTemplate.import_file(filename) {|name, attr| SpeechBalloonTemplate.store(name, attr)}
  end
  
end
