# -*- encoding: utf-8 -*-
#ユーザアカウント
require 'spec_helper'

describe User do
  before do
    FactoryGirl.create :admin
  end

  describe '作成に於いて' do
    context '作家の自動作成' do
      it '作家が作成されている' do
        lambda {
          @user = FactoryGirl.create( :user_yas)
        }.should change(Author, :count)
      end
      it '作家とユーザがリンクされている' do
        @user = FactoryGirl.create( :user_yas)
        Author.find_by_user_id(@user.id).should_not eq nil
      end
    end
  end
  
  describe 'トークン作成に於いて' do
    before do
      @user = FactoryGirl.create( :user_yas)
    end
    it 'トークンが変更されている' do
      lambda {
        @user.create_token
      }.should change(@user, :authentication_token)
    end
    it 'トークンが作成されている' do
      @user.create_token
      @user.authentication_token.should_not be_empty
    end
  end
  
  describe 'トークン削除に於いて' do
    before do
      @user = FactoryGirl.create( :user_yas)
      @user.create_token
    end
    it 'トークンが変更されている' do
      lambda {
        @user.delete_token
      }.should change(@user, :authentication_token)
    end
    it 'トークンが削除されている' do
      @user.delete_token
      @user.authentication_token.should be_blank
    end
  end
end
